;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; inttest.asm   v0.00.01   February 10th, 2002
;; NASM Assembly
;;
;; (02/10/2002)
;;
;; Copyright(c) 2002, Particle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; COM programs need this... DOS loads our program in memory like this
        ORG     0x100

;save location of old interrupt
        mov     ax,3509h
        int     21h
        mov     [Off9],bx
        mov     [Seg9],es

;set new interrupt
        push    ds
        mov     dx,NewNine      ; DS is already set correctly
        mov     ax,2509h
        int     21h
        pop     ds

;; loop until someone presses the ESC key
again:
        cmp     byte [keys + 1],0
        jz      again


;; restore the original interrupt
        push    ds
        mov     dx,[Off9]
        mov     ds,[Seg9]
        mov     ax,2509h
        int     21h
        pop     ds

; tell DOS we want to exit
        mov     ax,0x4C00
        int     21h

; location of original interrupt
Off9    dw      0
Seg9    dw      0

;array of KEYs, initialized
keys    times   128 db 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; new int 9 handler; prints out key code when a key is pressed.
;; NOTE: uses DOS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
NewNine:
        push    ax
        push    di
        in      al,60h          ; read keyboard scan code that was pressed
        xor     ah,ah
        call    printnum        ; print out that key code
        call    newline         ; skip line
        mov     di,ax
        in      al,61h          ; reinitialize the controller
        or      al,80h
        out     61h,al
        and     al,7Fh
        out     61h,al
        mov     al,20h
        out     20h,al
        mov     ax,di           ;process key
        and     al,80h
        jz      Press           ;process press
        and     di,7Fh          ;process release
        and     byte [keys + di],0
        jmp     ENDint
Press:  or      byte [keys + di],01h
ENDint: pop     di
        pop     ax
        iret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; print a number (optimized for size)
;; input: AX = number to print
;; NOTE: uses DOS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
base    equ     10              ;set the base of number to be printed
printnum:
        push    cx              ;save registers used... (very important)
        push    dx
        push    ax
        mov     cx,base         ;can set the base of a number to anything
        xor     dx,dx           ;for now, only work with 16 bit numbers.
        div     cx              ;need to use some register...
        cmp     ax,0            ;if result of a division is zero...
        je      .done           ;are we done?
        call    printnum        ;if not, go again...
.done:  add     dl,'0'         ;convert number to character
        mov     ah,02h          ;print to standard output
        int     21h             ;DOS service to write character
        pop     ax              ;pop all we have pushed
        pop     dx
        pop     cx
        ret                     ;get out of here...

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; print a line break
;; NOTE: uses DOS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
newline:
        push    ax
        push    dx
        mov     ah,02h
        mov     dl,10
        int     21h
        mov     dl,13
        int     21h
        pop     dx
        pop     ax
        ret

;; end
